using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_HotelPuntoVenta._0_Modelos;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using System.Transactions;
using System.Data.SqlClient;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_HotelPuntoVenta._1_Datos
{
    public class HPV_Caracteristicas_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_HPV_Caracteristicas_Listado_Modelo> g_lst_INTERNO_HPV_Caracteristicas_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_HPV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Caracteristicas).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_HPV_Caracteristicas_Listado_Modelo != null) && (g_lst_INTERNO_HPV_Caracteristicas_Listado_Modelo.Count() > 0))
                {
                    lst_HPV = g_lst_INTERNO_HPV_Caracteristicas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_HPV;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_HPV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Caracteristicas).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_HPV_Caracteristicas_Listado_Modelo != null) && (g_lst_INTERNO_HPV_Caracteristicas_Listado_Modelo.Count() > 0))
                {
                    dnm_HPV = g_lst_INTERNO_HPV_Caracteristicas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_HPV;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                //Filtros de Opciones
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }

                string str_SQL =
                     " SELECT " +
                         nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.id) + " = " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.id) + "," +
                         nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.codigo) + " = " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.codigo) + "," +
                         nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.descripcion) + " = " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.descripcion) + "," +
                         //ids
                         nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.idEmpresa) + " = " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idEmpresa) + "," +
                         nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.idCaracteristicaTipo) + " = " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idEmpresa) + "," +
                         //CaracteristicaTipo
                         (
                           (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.CaracteristicaTipo)))
                             ?
                                 (
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.CaracteristicaTipo_Codigo) + " = " + nameof(HPV_CaracteristicasTipos) + "." + nameof(HPV_CaracteristicasTipos.codigo) + "," +
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.CaracteristicaTipo_Descripcion) + " =" + nameof(HPV_CaracteristicasTipos) + "." + nameof(HPV_CaracteristicasTipos.descripcion) + "," +
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.CaracteristicaTipo_FechaBorrado) + " =" + nameof(HPV_CaracteristicasTipos) + "." + nameof(HPV_CaracteristicasTipos.fechaBorrado) + ","
                                 )
                             :
                                 (
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.CaracteristicaTipo_Codigo) + " = ''," +
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.CaracteristicaTipo_Descripcion) + " = ''," +
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.CaracteristicaTipo_FechaBorrado) + " = NULL, "
                                 )
                         ) +
                         //Empresa
                         (
                           (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.Empresa)))
                             ?
                                 (
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.Empresa_Descripcion) + " =" + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.Empresa_FechaBorrado) + " =" + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado)
                                 )
                             :
                                 (
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.Empresa_Codigo) + " = ''," +
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.Empresa_Descripcion) + " = ''," +
                                     nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.Empresa_FechaBorrado) + " = NULL "
                                 )
                         ) +
                    " FROM " + nameof(HPV_Caracteristicas) +
                        //CaracteristicaTipo
                        (
                             (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.CaracteristicaTipo)))
                                ?
                                    (
                                     " LEFT JOIN " + nameof(HPV_CaracteristicasTipos) + " ON " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idCaracteristicaTipo) + " = " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.id)
                                    )
                                : ("")
                        ) +
                        //Empresa
                        (
                             (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.Empresa)))
                                ?
                                    (
                                     " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idEmpresa) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id)
                                    )
                                : ("")
                        ) +
                        " WHERE " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.fechaBorrado) + " IS null AND " +
                           " ( " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idEmpresa) + "=@idEmpresa" +
                               (
                                   (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                       ? (" OR " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                       : " "
                               ) +
                           " ) AND " +
                           (_lng_id > -1 ? nameof(HPV_Caracteristicas) + "." + (nameof(HPV_Caracteristicas.id) + "=@id") : "1 = 1") + " AND " +
                            //Filtro por datos del padre relacionado
                            (
                                !str_Padre_Opcion.Equals("")
                                    //Empresa
                                    ? str_Padre_Opcion.Equals(Variables.G_STR_OPCION_GEN_EMPRESA)
                                        ? (nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idEmpresa) + "=@id_Padre")
                                        : ("1 = 1")
                                    : ("1 = 1")
                            );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));
                lst_Parametros.Add(new SqlParameter("@id_Padre", lng_Padre_id));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_HPV_Caracteristicas_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_HPV_Caracteristicas_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_HPV_Caracteristicas_Listado_Modelo g_mdl_INTERNO_HPV_Caracteristicas_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_HPV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Caracteristicas).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_HPV_Caracteristicas_Listado_Modelo_F3 != null)
                {
                    dnm_HPV = g_mdl_INTERNO_HPV_Caracteristicas_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_HPV;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_HPV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Caracteristicas).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_HPV_Caracteristicas_Listado_Modelo_F3 != null)
                {
                    dnm_HPV = g_mdl_INTERNO_HPV_Caracteristicas_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_HPV;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionas);

                //Filtros de Opciones
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }

                string str_SQL =
                     " SELECT distinct " +
                         nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.id) + " = " + nameof(HPV_Caracteristicas.id) + "," +
                         nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.codigo) + " = " + nameof(HPV_Caracteristicas.codigo) + "," +
                         nameof(INTERNO_HPV_Caracteristicas_Listado_Modelo.descripcion) + " = " + nameof(HPV_Caracteristicas.descripcion) +
                 " FROM " + nameof(HPV_Caracteristicas) +
                 " WHERE " + nameof(HPV_Caracteristicas.fechaBorrado) + " IS null AND " +
                          " ( " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idEmpresa) + "=@idEmpresa" +
                               (
                                   (_lst_idEmpresasRelacionas != null && _lst_idEmpresasRelacionas.Count > 0)
                                       ? (" OR " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                       : " "
                               ) +
                           " ) AND " +
                         (
                          (_lng_id > -1)
                            ? (nameof(HPV_Caracteristicas.id) + " = " + _lng_id)
                            : (
                                 //Filtrar por Codigo
                                 (_str_CampoBusqueda.Equals(nameof(HPV_Caracteristicas.codigo)))
                                     ? (nameof(HPV_Caracteristicas.codigo) + "=@Filtro")
                                     //Filtrar por Descripcion
                                     : (nameof(HPV_Caracteristicas.descripcion) + "=@Filtro")
                              )
                         )
                         + " AND " +
                         //Filtro por datos del padre relacionado
                         (
                             !str_Padre_Opcion.Equals("")
                                 //Empresa
                                 ? str_Padre_Opcion.Equals(Variables.G_STR_OPCION_GEN_EMPRESA)
                                     ? (nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idEmpresa) + "=@id_Padre")
                                     : ("1 = 1")
                                 : ("1 = 1")
                         );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@Filtro", _str_Filtro));
                lst_Parametros.Add(new SqlParameter("@id_Padre", lng_Padre_id));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_mdl_INTERNO_HPV_Caracteristicas_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_HPV_Caracteristicas_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }

        #endregion

        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                  " SELECT " +
                      nameof(INTERNO_MantenimientoSimple_Modelo.id) + " = " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.id) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.codigo) + " = " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.codigo) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.descripcion) + " = " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.descripcion) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.fechaBorrado) + " = " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.fechaBorrado) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.idEmpresa) + " = " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idEmpresa) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.F3_id) + " = " + nameof(HPV_CaracteristicasTipos) + "." + nameof(HPV_CaracteristicasTipos.id) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.F3_Codigo) + " = " + nameof(HPV_CaracteristicasTipos) + "." + nameof(HPV_CaracteristicasTipos.codigo) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.F3_Descripcion) + " = " + nameof(HPV_CaracteristicasTipos) + "." + nameof(HPV_CaracteristicasTipos.descripcion) + "," +
                      nameof(INTERNO_MantenimientoSimple_Modelo.F3_FechaBorrado) + " = " + nameof(HPV_CaracteristicasTipos) + "." + nameof(HPV_CaracteristicasTipos.fechaBorrado) +
                " FROM " + nameof(HPV_Caracteristicas) +
                //HPV_CaracteristicasTipos
                " LEFT JOIN " + nameof(HPV_CaracteristicasTipos) + " ON " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.idCaracteristicaTipo) + " = " + nameof(HPV_CaracteristicasTipos) + "." + nameof(HPV_CaracteristicasTipos.id) +
                " WHERE " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.fechaBorrado) + " IS null AND " +
                            nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoSimple_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private HPV_Caracteristicas g_mdl_HPV_Caracteristicas = null;
        public HPV_Caracteristicas Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_HPV_Caracteristicas;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_HPV_Caracteristicas = obj_Exferia_Entities.Database.SqlQuery<HPV_Caracteristicas>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<HPV_Caracteristicas> g_lst_HPV_Caracteristicas = null;

        public List<HPV_Caracteristicas> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(HPV_Caracteristicas),
                                                                                                    nameof(HPV_Caracteristicas.id),
                                                                                                    G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                                    _lst_Ids);

                    string str_SQL = Obtener_Consulta_Modelo() +
                                        //WHERE
                                        " WHERE " + str_Filtro_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_HPV_Caracteristicas;
        }

        public List<HPV_Caracteristicas> Obtener_ModeloListado_Por_IdIngrediente(long _lng_idIngrediente)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //INNER JOIN
                                   " INNER JOIN " + nameof(HPV_Ingredientes_Caracteristicas) + " ON " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.id) + " = " + nameof(HPV_Ingredientes_Caracteristicas) + "." + nameof(HPV_Ingredientes_Caracteristicas.idCaracteristica) +
                                   //WHERE
                                   " WHERE  " + nameof(HPV_Caracteristicas) + "." + nameof(HPV_Caracteristicas.fechaBorrado) + " IS null AND " +
                                                nameof(HPV_Ingredientes_Caracteristicas) + "." + nameof(HPV_Ingredientes_Caracteristicas.idIngrediente) + "=@idIngrediente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idIngrediente",  _lng_idIngrediente)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdIngrediente), true);
            }

            return g_lst_HPV_Caracteristicas;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_HPV_Caracteristicas = obj_Exferia_Entities.Database.SqlQuery<HPV_Caracteristicas>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(HPV_Caracteristicas.id) + "," +
                   nameof(HPV_Caracteristicas.codigo) + "," +
                   nameof(HPV_Caracteristicas.descripcion) + "," +
                   nameof(HPV_Caracteristicas.idCaracteristicaTipo) + "," +
                   nameof(HPV_Caracteristicas.idEmpresa) + "," +
                   nameof(HPV_Caracteristicas.fechaBorrado) +
               " FROM " + nameof(HPV_Caracteristicas);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                INTERNO_MantenimientoSimple_Modelo mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar = (INTERNO_MantenimientoSimple_Modelo)_mdl_obj;
                HPV_Caracteristicas mdl_HPV_Caracteristicas_DatosViejos = new HPV_Caracteristicas();

                // Ver si existe ######################################################################
                HPV_Caracteristicas mdl_HPV_Caracteristicas_Final = Obtener_Modelo_Por_Id(mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_HPV_Caracteristicas_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_HPV_Caracteristicas_Final, mdl_HPV_Caracteristicas_DatosViejos, false, false);

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_HPV_Caracteristicas_Final, mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar);


                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(HPV_Caracteristicas) +
                                            " SET " +
                                                nameof(HPV_Caracteristicas.codigo) + "=@codigo," +
                                                nameof(HPV_Caracteristicas.descripcion) + "=@descripcion," +
                                                nameof(HPV_Caracteristicas.idCaracteristicaTipo) + "=@idCaracteristicaTipo," +
                                                nameof(HPV_Caracteristicas.idEmpresa) + "=@idEmpresa," +
                                                nameof(HPV_Caracteristicas.fechaBorrado) + "=@fechaBorrado" +
                                            " WHERE " +
                                                nameof(HPV_Caracteristicas.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.descripcion),
                        mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.F3_id > -1
                            ?   new SqlParameter("@idCaracteristicaTipo", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.F3_id.Value)
                            :   new SqlParameter("@idCaracteristicaTipo",  DBNull.Value),
                        new SqlParameter("@idEmpresa",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.idEmpresa),
                        mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_HPV_Caracteristicas_Final = new HPV_Caracteristicas();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_HPV_Caracteristicas_Final, mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(HPV_Caracteristicas) +
                                               " (" +
                                                       nameof(HPV_Caracteristicas.codigo) + "," +
                                                       nameof(HPV_Caracteristicas.descripcion) + "," +
                                                       nameof(HPV_Caracteristicas.idCaracteristicaTipo) + "," +
                                                       nameof(HPV_Caracteristicas.idEmpresa) + "," +
                                                       nameof(HPV_Caracteristicas.fechaBorrado) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(HPV_Caracteristicas.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@codigo," +
                                                   "@descripcion," +
                                                   "@idCaracteristicaTipo," +
                                                   "@idEmpresa," +
                                                   "@fechaBorrado" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.descripcion),
                        mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.F3_id > -1
                            ?   new SqlParameter("@idCaracteristicaTipo", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.F3_id.Value)
                            :   new SqlParameter("@idCaracteristicaTipo",  DBNull.Value),
                        new SqlParameter("@idEmpresa",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.idEmpresa),
                        mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)

                    };
                    #endregion

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(HPV_Caracteristicas), mdl_HPV_Caracteristicas_DatosViejos, mdl_HPV_Caracteristicas_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_ValorDevuelto_Modelo;
        }

        private void Cargar_DatosModelo(HPV_Caracteristicas _mdl_HPV_Caracteristicas, INTERNO_MantenimientoSimple_Modelo _mdl_INTERNO_MantenimientoSimple_Modelo)
        {
            //Cargar los datos Nuevos del Modelo
            _mdl_HPV_Caracteristicas.id = _mdl_INTERNO_MantenimientoSimple_Modelo.id;
            _mdl_HPV_Caracteristicas.codigo = _mdl_INTERNO_MantenimientoSimple_Modelo.codigo;
            _mdl_HPV_Caracteristicas.descripcion = _mdl_INTERNO_MantenimientoSimple_Modelo.descripcion;
            _mdl_HPV_Caracteristicas.idEmpresa = _mdl_INTERNO_MantenimientoSimple_Modelo.idEmpresa;
            _mdl_HPV_Caracteristicas.idCaracteristicaTipo = _mdl_INTERNO_MantenimientoSimple_Modelo.F3_id != null ? _mdl_INTERNO_MantenimientoSimple_Modelo.F3_id.Value : -1;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                HPV_Caracteristicas mdl_HPV_Caracteristicas_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_HPV_Caracteristicas_Final != null)
                {
                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(HPV_Caracteristicas) +
                                               " SET " +
                                               nameof(HPV_Caracteristicas.fechaBorrado) + "=@fechaBorrado " +
                                           " WHERE " +
                                               nameof(HPV_Caracteristicas.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(HPV_Caracteristicas), null, mdl_HPV_Caracteristicas_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }
                    
                // Devolver también el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Caracteristicas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
